;----------------------------------------------------------------------------
;File name:	CSLIP_HD.SH			Revision date:	1997.07.27
;C->S Port by:	Ulf Ronald Andersson		Port begun:	1996.08.02
;Original C by:	Dan Ackerman & Steve Adam
;----------------------------------------------------------------------------
;
	XREF	bdev	;extern DEV_LIST *bdev;
;
;
	XREF	memcpy	;/*extern void	*memcpy (void *, const void *, unsigned long);*/
	XREF	memcmp	;extern int	memcmp (const void *, const void *, unsigned long);
	XREF	memset	;extern void    *memset( void *ptr, int val, size_t len );
	XREF	bzero	;/*extern void	*bzero (void *, unsigned long);*/
;
;
;	/* SLIP special character codes */
;
slip_ch_END		equ 0300	;indicates end of packet
slip_ch_ESC		equ 0333	;indicates byte stuffing
slip_ch_ESC_END		equ 0334	;ESC ESC_END means END data byte
slip_ch_ESC_ESC		equ 0335	;ESC ESC_ESC means ESC data byte
;
;
;	/* Bits in first octet of compressed packet */
;
NEW_C		equ $40	;flag bits for what changed in a packet
NEW_I		equ $20
NEW_S		equ $08
NEW_A		equ $04
NEW_W		equ $02
NEW_U		equ $01
;
TCP_PUSH_BIT	equ $10
;
NEW_C_bs	equ 6	;flag bit numbers for what changed in a packet
NEW_I_bs	equ 5
NEW_S_bs	equ 3
NEW_A_bs	equ 2
NEW_W_bs	equ 1
NEW_U_bs	equ 0
;
TCP_PUSH_BIT_bs	equ 4
;
;
;	/* reserved, special-case values of above */
;
SPECIAL_I	equ (NEW_S|NEW_W|NEW_U)		;echoed interactive traffic
SPECIAL_D	equ (NEW_S|NEW_A|NEW_W|NEW_U)	;unidirectional data
SPECIALS_MASK	equ (NEW_S|NEW_A|NEW_W|NEW_U)
;
;
;;;#define BCMP(p1,p2,n)	memcmp((p2), (p1), (uint32)(n))
;;;#define BCOPY(p1,p2,n)	memcpy((p2), (p1), (uint32)(n))
;;;#define ovbcopy(p1,p2,n)	memcpy((p2), (p1), (uint32)(n))
;
;----------------------------------------------------------------------------
;End of file:	CSLIP_HD.SH
;----------------------------------------------------------------------------
