;----------------------------------------------------------------------------
;File name:	TRACER.SH			Revision date:	1998.06.25
;Created by:	Ulf Ronald Andersson		Creation date:	1998.06.23
;----------------------------------------------------------------------------
;needed includes are:
;;;	include	"uran\STRUCT.SH"
;;;	include	"uran\URAn_SYS.SH"
;;;	include	"uran\URAn_DOS.SH"
;----------------------------------------------------------------------------
trace_mode = 1
;----------------------------------------------------------------------------
.MACRO	trace	code
	.IF	trace_mode
	bsr	trace_CODE
	dc.w	code
	.ENDIF
.ENDM	trace
;----------------------------------------------------------------------------
.MACRO	trace_CODE
	.IF	trace_mode
trace_CODE:
	link	a6,#0
	movem.l	d0-d2/a0-a3,-(sp)
	lea	.trace_s(pc),a3
	move.l	4(a6),a1
	move.b	(a1),.trace_char-.trace_s(a3)
	addq.l	#2,4(a6)
	gemdos	Cconws,(a3)
	gemdos	Crawcin
	lea	.trace_count-.trace_s(a3),a0
	addq.b	#1,(a0)
	and.b	#$7F,(a0)
	or.b	#$40,(a0)
	movem.l	(sp)+,d0-d2/a0-a3
	unlk	a6
	rts
;-------
.trace_s:
	dc.b	'Trace = "'
.trace_char:
	dc.b	'@:'
.trace_count:
	dc.b	'@"',CR,LF,NUL
	.EVEN
trace_CODE_end:
	.ENDIF
.ENDM	trace_CODE
;----------------------------------------------------------------------------
;End of file:	TRACER.SH
;----------------------------------------------------------------------------
