/*--------------------------------------------------------------------------*/
/* File name:	BAR_MENU.C						Revision date:	1997.09.25	*/
/* Created by:	Ulf Ronald Andersson			Creation date:	1997.09.25	*/
/*--------------------------------------------------------------------------*/

#include	<string.h>
#include	<aes.h>

char	zz_text1[] = " Bar     ";
char	zz_text2[] = "  About Bar...   ";
char	zz_text3[] = "-----------------";
char	zz_text4[] = "  Accessory   1  ";
char	zz_text5[] = "  Accessory   2  ";
char	zz_text6[] = "  Accessory   3  ";
char	zz_text7[] = "  Accessory   4  ";
char	zz_text8[] = "  Accessory   5  ";
char	zz_text9[] = "  Accessory   6  ";

typedef	struct
{	short w00, w02, w04;
	short w06, w08, w10;
	long  l12;
	short w16, w18, w20, w22;
}	GEN_OBJ;

GEN_OBJ	BAR_menu_0[14] =
{	{	-1,1,4, 	25,0,0,			0x0000,			0,0,80,25		},	/* 00 */
	{	4,2,2,		20,0,0,			0x1100,			0,0,80,0x201	},	/* 01 */
	{	1,3,3,		25,0,0,			0x0000,			2,0,8,0x301		},	/* 02 */
	{	2,-1,-1,	32,0,0,		(long) zz_text1,	0,0,8,0x301		},	/* 03 */
	{	0,5,5,		25,0,0,			0x0000,			0,0x301,80,23	},	/* 04 */
	{	4,6,13,		20,0,0,			0xFF1100L,		2,0,17,8		},	/* 05 */
	{	7,-1,-1,	28,0,0,		(long) zz_text2,	0,0,17,1		},	/* 06 */
	{	8,-1,-1,	28,0,8,		(long) zz_text3,	0,1,17,1		},	/* 07 */
	{	9,-1,-1,	28,0,0,		(long) zz_text4,	0,2,17,1		},	/* 08 */
	{	10,-1,-1,	28,0,0,		(long) zz_text5,	0,3,17,1		},	/* 09 */
	{	11,-1,-1,	28,0,0,		(long) zz_text6,	0,4,17,1		},	/* 10 */
	{	12,-1,-1,	28,0,0,		(long) zz_text7,	0,5,17,1		},	/* 11 */
	{	13,-1,-1,	28,0,0,		(long) zz_text8,	0,6,17,1		},	/* 12 */
	{	5,-1,-1,	28,32,0,	(long) zz_text9,	0,7,17,1		}	/* 13 */
};	/* ends BAR_menu_0 */

GEN_OBJ	BAR_menu_1[14];

/*--------------------------------------------------------------------------*/

void	init_menu(void)
{	short i;
	memcpy( BAR_menu_1, BAR_menu_0, sizeof(BAR_menu_0));
	for	( i = 1; i<14; i++)
		rsrc_obfix( (OBJECT *) BAR_menu_1, i);
}	/* ends init_menu */

/*--------------------------------------------------------------------------*/
/* End of file:	BAR_MENU.C													*/
/*--------------------------------------------------------------------------*/
