/************************************************************************/
/*                                                                      */
/*    SCANCODE.H             Scancodes der Tastatur                     */
/*                           fr evnt_keybd()                           */
/*                                                                      */
/*       Copyright (c) 1989 Borland International                       */
/*       All rights reserved.                                           */
/*                                                                      */
/************************************************************************/

#define CNTRL_A                     0x1e01
#define CNTRL_B                     0x3002
#define CNTRL_C                     0x2e03
#define CNTRL_D                     0x2004
#define CNTRL_E                     0x1205
#define CNTRL_F                     0x2106
#define CNTRL_G                     0x2207
#define CNTRL_H                     0x2308
#define CNTRL_I                     0x1709
#define CNTRL_J                     0x240a
#define CNTRL_K                     0x250b
#define CNTRL_L                     0x260c
#define CNTRL_M                     0x320d
#define CNTRL_N                     0x310e
#define CNTRL_O                     0x180f
#define CNTRL_P                     0x1910
#define CNTRL_Q                     0x1011
#define CNTRL_R                     0x1312
#define CNTRL_S                     0x1f13
#define CNTRL_T                     0x1414
#define CNTRL_U                     0x1615
#define CNTRL_V                     0x2f16
#define CNTRL_W                     0x1117
#define CNTRL_X                     0x2d18
#define CNTRL_Y                     0x2c19
#define CNTRL_Z                     0x151a
#define CNTRL_AE                    0X2804	/* German KB only */
#define CNTRL_OE                    0x2714	/* German KB only */
#define CNTRL_UE                    0x1a01	/* German KB only */
#define CNTRL_1                     0x0211
#define CNTRL_2                     0x0300
#define CNTRL_3                     0x0413
#define CNTRL_4                     0x0514
#define CNTRL_5                     0x0615
#define CNTRL_6                     0x071e
#define CNTRL_7                     0x0817
#define CNTRL_8                     0x0918
#define CNTRL_9                     0x0a19
#define CNTRL_0                     0x0b10

#define ALT_A                       0x1e00
#define ALT_B                       0x3000
#define ALT_C                       0x2e00
#define ALT_D                       0x2000
#define ALT_E                       0x1200
#define ALT_F                       0x2100
#define ALT_G                       0x2200
#define ALT_H                       0x2300
#define ALT_I                       0x1700
#define ALT_J                       0x2400
#define ALT_K                       0x2500
#define ALT_L                       0x2600
#define ALT_M                       0x3200
#define ALT_N                       0x3100
#define ALT_O                       0x1800
#define ALT_P                       0x1900
#define ALT_Q                       0x1000
#define ALT_R                       0x1300
#define ALT_S                       0x1f00
#define ALT_T                       0x1400
#define ALT_U                       0x1600
#define ALT_V                       0x2f00
#define ALT_W                       0x1100
#define ALT_X                       0x2d00
#define ALT_Y                       0x2c00
#define ALT_Z                       0x1500
#define ALT_AE                      0x285d	/* German KB only */
#define ALT_OE                      0x275b	/* German KB only */
#define ALT_UE                      0x1a40	/* German KB only */
#define ALT_1                       0x7800
#define ALT_2                       0x7900
#define ALT_3                       0x7a00
#define ALT_4                       0x7b00
#define ALT_5                       0x7c00
#define ALT_6                       0x7d00
#define ALT_7                       0x7e00
#define ALT_8                       0x7f00
#define ALT_9                       -0x8000
#define ALT_0                       -0x7f00

#define SH_ALT_AE                   0x287d	/* German KB only */
#define SH_ALT_OE                   0x277b	/* German KB only */
#define SH_ALT_UE                   0x1a5c	/* German KB only */

#define BACKSPACE                   0x0e08
#define DELETE                      0x537f
#define INSERT                      0x5200
#define SHFT_INS                    0x5230
#define RETURN                      0x1c0d
#define ENTER                       0x720d

#define CUR_UP                      0x4800
#define SHFT_CU                     0x4838	/* wrong !!! */
#define CUR_LEFT                    0x4b00
#define CNTRL_CL					0x7300	/* new */
#define SHFT_CL                     0x4b34	/* wrong !!! */
#define CUR_RIGHT                   0x4d00
#define CNTRL_CR					0x7400	/* new */
#define SHFT_CR                     0x4d36	/* wrong !!! */
#define CUR_DOWN                    0x5000
#define SHFT_CD                     0x5032	/* wrong !!! */

#define HOME                        0x4700
#define SHFT_HOME                   0x4737	/* wrong !!! */
#define UNDO                        0x6100
#define TAB                         0x0f09
#define HELP                        0x6200
#define F1                          0x3b00
#define SHFT_F1                     0x5400
#define F2                          0x3c00
#define SHFT_F2                     0x5500
#define F3                          0x3d00
#define SHFT_F3                     0x5600
#define F4                          0x3e00
#define SHFT_F4                     0x5700
#define F5                          0x3f00
#define SHFT_F5                     0x5800
#define F6                          0x4000
#define SHFT_F6                     0x5900
#define F7                          0x4100
#define SHFT_F7                     0x5a00
#define F8                          0x4200
#define SHFT_F8                     0x5b00
#define F9                          0x4300
#define SHFT_F9                     0x5c00
#define F10                         0x4400
#define SHFT_F10                    0x5d00

/************************************************************************/
